<script lang="ts">
  import Roll from './Roll.svelte'
  import { attributeNames } from '../../module/model/character-data.js'
  import type { ModifierDescriptor } from '../../module/model/modifier.js'
  import type { BaseSkill, Testable } from '../../module/model/properties.js'

  export var localize: (_key: string) => string
  export var skill: Testable<BaseSkill>

  export var callback: (
    modifiers: Map<string, ModifierDescriptor>,
    options?: Record<string, unknown>
  ) => void
  export var modifiers = new Map<string, ModifierDescriptor>()

  let options = { testAttributes: [...skill.testAttributes] }
</script>

<Roll bind:modifiers {callback} {localize} bind:options>
  <div slot="options" data-testid="skill-name">
    <h1>
      {skill.name} ({skill.value})
    </h1>
    <slot name="skill-info" />
  </div>
  <svelte:fragment slot="options-bottom">
    <div>
      {#each [0, 1, 2] as attributeKey}
        <select
          bind:value={options.testAttributes[attributeKey]}
          data-testid={`test-attribute-${attributeKey}`}
        >
          {#each attributeNames as attributeName}
            <option value={attributeName}>{localize(attributeName)}</option>
          {/each}
        </select>
      {/each}
    </div>
    <slot name="skill-options" />
  </svelte:fragment>
</Roll>
